Package ghidra.generic.util.datastruct

# Class TreeValueSortedMap.ValueSortedTreeMapValues

java.lang.Object
java.util.AbstractCollection<V>
ghidra.generic.util.datastruct.TreeValueSortedMap.ValueSortedTreeMapValues

All Implemented Interfaces:
  `SortedList<V>`, `Iterable<V>`, `Collection<V>`, `Deque<V>`, `List<V>`, `Queue<V>`

Enclosing class:
  TreeValueSortedMap<K,V>

protected class TreeValueSortedMap.ValueSortedTreeMapValues extends AbstractCollection<V> implements SortedList<V>, Deque<V>
A public view of the map as a list of values This view implements `SortedList` and `Deque`, since an ordered collection ought to behave like a list, and since this implementation is meant to be used as a dynamic-cost priority queue. Generally, only the removal mutation methods are supported, all others are not supported.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(int index, V element)`
  `boolean`
  `add(V e)`
  `boolean`
  `addAll(int index, Collection<? extends V> c)`
  `boolean`
  `addAll(Collection<? extends V> c)`
  `void`
  `addFirst(V e)`
  `void`
  `addLast(V e)`
  `int`
  `ceilingIndex(V element)`
  Returns the least index in this list whose element is greater than or equal to the specified element
  `void`
  `clear()`
  `boolean`
  `contains(Object o)`
  `Iterator<V>`
  `descendingIterator()`
  `V`
  `element()`
  `int`
  `floorIndex(V element)`
  Returns the greatest index in this list whose element is less than or equal to the specified element
  `V`
  `get(int index)`
  `V`
  `getFirst()`
  `V`
  `getLast()`
  `int`
  `higherIndex(V element)`
  Returns the least index in this list whose element is strictly greater the specified element
  `int`
  `indexOf(Object o)`
  `boolean`
  `isEmpty()`
  `Iterator<V>`
  `iterator()`
  `int`
  `lastIndexOf(Object o)`
  `ListIterator<V>`
  `listIterator()`
  `ListIterator<V>`
  `listIterator(int index)`
  `int`
  `lowerIndex(V element)`
  Returns the greatest index in this list whose element is strictly less than the specified element
  `boolean`
  `offer(V e)`
  `boolean`
  `offerFirst(V e)`
  `boolean`
  `offerLast(V e)`
  `V`
  `peek()`
  `V`
  `peekFirst()`
  `V`
  `peekLast()`
  `V`
  `poll()`
  `V`
  `pollFirst()`
  `V`
  `pollLast()`
  `V`
  `pop()`
  `void`
  `push(V e)`
  `V`
  `remove()`
  `V`
  `remove(int index)`
  `boolean`
  `remove(Object o)`
  `V`
  `removeFirst()`
  `boolean`
  `removeFirstOccurrence(Object o)`
  `V`
  `removeLast()`
  `boolean`
  `removeLastOccurrence(Object o)`
  `V`
  `set(int index, V element)`
  `int`
  `size()`
  `List<V>`
  `subList(int fromIndex, int toIndex)`
  This operation is not supported

  ### Methods inherited from class java.util.AbstractCollection

  `containsAll, removeAll, retainAll, toArray, toArray, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Collection

  `parallelStream, removeIf, stream, toArray`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

  ### Methods inherited from interface java.util.List

  `containsAll, equals, hashCode, removeAll, replaceAll, retainAll, sort, spliterator, toArray, toArray`

- ## Method Details

  - ### add

    public void add(int index, V element)
    Specified by:
      `add` in interface `List<V>`

  - ### add

    public boolean add(V e)
    Specified by:
      `add` in interface `Collection<V>`
    Specified by:
      `add` in interface `Deque<V>`
    Specified by:
      `add` in interface `List<V>`
    Specified by:
      `add` in interface `Queue<V>`
    Overrides:
      `add` in class `AbstractCollection<V>`

  - ### addAll

    public boolean addAll(Collection<? extends V> c)
    Specified by:
      `addAll` in interface `Collection<V>`
    Specified by:
      `addAll` in interface `Deque<V>`
    Specified by:
      `addAll` in interface `List<V>`
    Overrides:
      `addAll` in class `AbstractCollection<V>`

  - ### addAll

    public boolean addAll(int index, Collection<? extends V> c)
    Specified by:
      `addAll` in interface `List<V>`

  - ### addFirst

    public void addFirst(V e)
    Specified by:
      `addFirst` in interface `Deque<V>`

  - ### addLast

    public void addLast(V e)
    Specified by:
      `addLast` in interface `Deque<V>`

  - ### clear

    public void clear()
    Specified by:
      `clear` in interface `Collection<V>`
    Specified by:
      `clear` in interface `List<V>`
    Overrides:
      `clear` in class `AbstractCollection<V>`

  - ### contains

    public boolean contains(Object o)
    Specified by:
      `contains` in interface `Collection<V>`
    Specified by:
      `contains` in interface `Deque<V>`
    Specified by:
      `contains` in interface `List<V>`
    Overrides:
      `contains` in class `AbstractCollection<V>`

  - ### descendingIterator

    public Iterator<V> descendingIterator()
    Specified by:
      `descendingIterator` in interface `Deque<V>`

  - ### element

    public V element()
    Specified by:
      `element` in interface `Deque<V>`
    Specified by:
      `element` in interface `Queue<V>`

  - ### get

    public V get(int index)
    Specified by:
      `get` in interface `List<V>`

  - ### getFirst

    public V getFirst()
    Specified by:
      `getFirst` in interface `Deque<V>`

  - ### getLast

    public V getLast()
    Specified by:
      `getLast` in interface `Deque<V>`

  - ### indexOf

    public int indexOf(Object o)
    Specified by:
      `indexOf` in interface `List<V>`

  - ### lowerIndex

    public int lowerIndex(V element)
    Description copied from interface: `SortedList`
    Returns the greatest index in this list whose element is strictly less than the specified element
    Specified by:
      `lowerIndex` in interface `SortedList<V>`
    Parameters:
      `element` - the element to search for
    Returns:
      the index of the found element, or -1

  - ### floorIndex

    public int floorIndex(V element)
    Description copied from interface: `SortedList`
    Returns the greatest index in this list whose element is less than or equal to the specified element

    If multiples of the specified element exist, this returns the least index of that element.

    Specified by:
      `floorIndex` in interface `SortedList<V>`
    Parameters:
      `element` - the element to search for
    Returns:
      the index of the found element, or -1

  - ### ceilingIndex

    public int ceilingIndex(V element)
    Description copied from interface: `SortedList`
    Returns the least index in this list whose element is greater than or equal to the specified element

    If multiples of the specified element exist, this returns the greatest index of that element.

    Specified by:
      `ceilingIndex` in interface `SortedList<V>`
    Parameters:
      `element` - the element to search for
    Returns:
      the index of the found element, or -1

  - ### higherIndex

    public int higherIndex(V element)
    Description copied from interface: `SortedList`
    Returns the least index in this list whose element is strictly greater the specified element
    Specified by:
      `higherIndex` in interface `SortedList<V>`
    Parameters:
      `element` - the element to search for
    Returns:
      the index of the found element, or -1

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `Collection<V>`
    Specified by:
      `isEmpty` in interface `List<V>`
    Overrides:
      `isEmpty` in class `AbstractCollection<V>`

  - ### iterator

    public Iterator<V> iterator()
    Specified by:
      `iterator` in interface `Collection<V>`
    Specified by:
      `iterator` in interface `Deque<V>`
    Specified by:
      `iterator` in interface `Iterable<V>`
    Specified by:
      `iterator` in interface `List<V>`
    Specified by:
      `iterator` in class `AbstractCollection<V>`

  - ### lastIndexOf

    public int lastIndexOf(Object o)
    Specified by:
      `lastIndexOf` in interface `List<V>`

  - ### listIterator

    public ListIterator<V> listIterator()
    Specified by:
      `listIterator` in interface `List<V>`

  - ### listIterator

    public ListIterator<V> listIterator(int index)
    Specified by:
      `listIterator` in interface `List<V>`

  - ### offer

    public boolean offer(V e)
    Specified by:
      `offer` in interface `Deque<V>`
    Specified by:
      `offer` in interface `Queue<V>`

  - ### offerFirst

    public boolean offerFirst(V e)
    Specified by:
      `offerFirst` in interface `Deque<V>`

  - ### offerLast

    public boolean offerLast(V e)
    Specified by:
      `offerLast` in interface `Deque<V>`

  - ### peek

    public V peek()
    Specified by:
      `peek` in interface `Deque<V>`
    Specified by:
      `peek` in interface `Queue<V>`

  - ### peekFirst

    public V peekFirst()
    Specified by:
      `peekFirst` in interface `Deque<V>`

  - ### peekLast

    public V peekLast()
    Specified by:
      `peekLast` in interface `Deque<V>`

  - ### poll

    public V poll()
    Specified by:
      `poll` in interface `Deque<V>`
    Specified by:
      `poll` in interface `Queue<V>`

  - ### pollFirst

    public V pollFirst()
    Specified by:
      `pollFirst` in interface `Deque<V>`

  - ### pollLast

    public V pollLast()
    Specified by:
      `pollLast` in interface `Deque<V>`

  - ### pop

    public V pop()
    Specified by:
      `pop` in interface `Deque<V>`

  - ### push

    public void push(V e)
    Specified by:
      `push` in interface `Deque<V>`

  - ### remove

    public V remove()
    Specified by:
      `remove` in interface `Deque<V>`
    Specified by:
      `remove` in interface `Queue<V>`

  - ### remove

    public V remove(int index)
    Specified by:
      `remove` in interface `List<V>`

  - ### remove

    public boolean remove(Object o)
    Specified by:
      `remove` in interface `Collection<V>`
    Specified by:
      `remove` in interface `Deque<V>`
    Specified by:
      `remove` in interface `List<V>`
    Overrides:
      `remove` in class `AbstractCollection<V>`

  - ### removeFirst

    public V removeFirst()
    Specified by:
      `removeFirst` in interface `Deque<V>`

  - ### removeFirstOccurrence

    public boolean removeFirstOccurrence(Object o)
    Specified by:
      `removeFirstOccurrence` in interface `Deque<V>`

  - ### removeLast

    public V removeLast()
    Specified by:
      `removeLast` in interface `Deque<V>`

  - ### removeLastOccurrence

    public boolean removeLastOccurrence(Object o)
    Specified by:
      `removeLastOccurrence` in interface `Deque<V>`

  - ### set

    public V set(int index, V element)
    Specified by:
      `set` in interface `List<V>`

  - ### size

    public int size()
    Specified by:
      `size` in interface `Collection<V>`
    Specified by:
      `size` in interface `Deque<V>`
    Specified by:
      `size` in interface `List<V>`
    Specified by:
      `size` in class `AbstractCollection<V>`

  - ### subList

    public List<V> subList(int fromIndex, int toIndex)
    This operation is not supported
    Specified by:
      `subList` in interface `List<V>`